import java.io.*;
import java.util.*;


public class olymp_al {
  static class Log implements Comparable <Log> {
    double L;
    ArrayList <Integer> w;
    Log (int ll, int id) {
      w = new ArrayList <Integer> ();
      L = ll;
      w.add (id);
    };

    public int compareTo (Log z) {
      if (L > z.L) return -1;
      if (L < z.L) return 1;
      return 0;
    };
  };

  static class Worker implements Comparable <Worker> {
    double V;
    ArrayList <Integer> w;
    Worker (int vv, int id) {
      w = new ArrayList <Integer> ();
      V = vv;
      w.add (id);
    };

    public int compareTo (Worker z) {
      if (V > z.V) return -1;
      if (V < z.V) return 1;
      return 0;
    };
  };


  static class OutEvent implements Comparable <OutEvent> {
    double X;
    int i, j;

    OutEvent (double XX, int ii, int jj) {
      X = XX;
      i = ii;
      j = jj;
    };

    public int compareTo (OutEvent z) {
      if (X < z.X) return -1;
      if (X > z.X) return 1;
      return 0;
    };

    public String toString () {
      return X + " " + i + " " + j;
    };
  };


  public static void main (String [] a) throws Exception {
    BufferedReader in = new BufferedReader (new FileReader (new File ("olymp.in")));
    PrintWriter out = new PrintWriter ("olymp.out");
    StringTokenizer t = new StringTokenizer (in.readLine ());
    int n = Integer.parseInt (t.nextToken ());
    if (t.hasMoreTokens ()) throw new Exception ("end-of-line expected");
    if (n < 1 || n > 50) throw new Exception ("invalid n");

    Log L [] = new Log [n];
    t = new StringTokenizer (in.readLine ());
    for (int i = 0; i < n; i++) {
      int ql = Integer.parseInt (t.nextToken ());
      if (ql < 1 || ql > 1000) throw new Exception ("invalid length");
      L[i] = new Log (ql, i);
    };
    if (t.hasMoreTokens ()) throw new Exception ("end-of-line expected");

    Arrays.sort (L);

    t = new StringTokenizer (in.readLine ());

    int k = Integer.parseInt (t.nextToken ());
    if (t.hasMoreTokens ()) throw new Exception ("end-of-line expected");
    if (k < 1 || k > 50) throw new Exception ("invalid k");

    Worker [] V = new Worker [Math.max (n, k)];
    t = new StringTokenizer (in.readLine ());
    for (int i = 0; i < k; i++) {
      int qv = Integer.parseInt (t.nextToken ());
      if (qv < 1 || qv > 1000) throw new Exception ("invalid speed");
      V[i] = new Worker (qv, i);
    };
    if (t.hasMoreTokens ()) throw new Exception ("end-of-line expected");

    if (in.ready ()) throw new Exception ("end-of-file expected");

    for (int i = k; i < n; i++) V[i] = new Worker (0, i);

    Arrays.sort (V);

    double T = 0;

    ArrayList <OutEvent> o = new ArrayList <OutEvent> ();
    while (n > 0) {
      double mn = 1e100;
      int mi = -1, mj = -1;
      for (int i = 0; i < n; i++) if (L[i].L > 1e-8 && V[i].V > 0 && L[i].L / V[i].V < mn) {
        mn = L[i].L / V[i].V;
        mi = n - 1;
        mj = n - 1;
      };
      for (int i = 0; i < n; i++)
         for (int j = i + 1; j < n; j++) {
           double ct;
           if (Math.abs (L[i].L * L[j].w.size () - L[j].L * L[i].w.size ()) < 1e-8) ct = 0; else
           if (Math.abs (V[i].V * V[j].w.size () - V[j].V * V[i].w.size ()) < 1e-8) ct = 1e100; 
             else ct = (L[i].L * L[j].w.size () - L[j].L * L[i].w.size ()) / 
                       (V[i].V * V[j].w.size () - V[j].V * V[i].w.size ());
           if (ct < mn) {
             mn = ct;
             mi = i;
             mj = j;
           };
           if (ct < -1e-8) throw new Exception ("bug in program");
         };
      if (mn == 1e100) throw new Exception ("bug in program");
      //System.out.println (mn + " " + mi + " " + mj);
      for (int i = 0; i < n; i++) {
        if (L[i].w.size () != V[i].w.size ()) throw new Exception ("bug in program");
        for (int j = 0; j < L[i].w.size (); j++) {
          if (Math.abs (mn) > 1e-8) {
            double ct = T + mn / L[i].w.size () * j;
            //System.out.println (T + " " + mn + " " + j + " " + ct);
            for (int l = 0; l < V[i].w.size (); l++)
              if (V[i].w.get (l) < k)
                o.add (new OutEvent (ct, L[i].w.get ((j + l) % L[i].w.size ()) + 1, V[i].w.get (l) + 1));
          };
        };
      };
      for (int i = 0; i < n; i++)
        L[i].L -= V[i].V * mn;

      T += mn;

      if (mi != mj) {
        if (L[mj].L > 1e-8) L[mi].w.addAll (L[mj].w);
        if (L[mj].L > 1e-8) V[mi].w.addAll (V[mj].w);
        if (L[mj].L > 1e-8) L[mi].L += L[mj].L;
        if (L[mj].L > 1e-8) V[mi].V += V[mj].V;

        for (int i = mj; i < n - 1; i++) {
          L[i] = L[i + 1];
          V[i] = V[i + 1];
        };
      };


      --n;
      while (n > 0 && L[n - 1].L < 1e-8) {
        /*if (n > 1) {
          L[n - 2].w.addAll (L[n - 1].w);
          V[n - 2].w.addAll (V[n - 1].w);
          L[n - 2].L += L[n - 1].L;
          V[n - 2].V += V[n - 1].V;
        };*/
        --n;
      };
    };
    out.println (T);
    Collections.sort (o);
    for (OutEvent x : o) out.println (x);
    out.close ();
  };
};