#include <cassert>
#include <cmath>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <functional>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define F first
#define S second
#define pb push_back

typedef double dbl;

#define eps 1e-8

#define maxn 53

typedef pair <dbl, int> T;

int n, k, m;
T s[maxn], v[maxn];
int pos[maxn];
dbl vv[maxn];

dbl CalcT()
{
  dbl T = 0, sumS = 0, sumV = 0;
  forn(i, n)
  {
    if (i < k)
      sumV += v[i].F;
    sumS += max(0.0, s[i].F);
    T >?= sumS / sumV;
  }
  return T;
}

struct event
{
  dbl t;
  int i, j;

  event() {}
  event( dbl _t, int _i, int _j ) { t = _t, i = _i, j = _j; }
};

bool operator < ( event a, event b ) { return a. t < b.t; }

event e[maxn * maxn];

int main()
{
  freopen("olymp.in", "r", stdin);
  freopen("olymp.out", "w", stdout);

  scanf("%d", &n);
  assert(1 <= n && n <= 50);
  forn(i, n)
  {
    scanf("%lf", &s[i].F), s[i].S = i;
    assert(1 <= s[i].F && s[i].F <= 1000 && s[i].F == (int)s[i].F);
  }
  scanf("%d", &k);
  assert(1 <= k && k <= 50);
  forn(i, k)
  {
    scanf("%lf", &v[i].F), v[i].S = i;
    assert(1 <= v[i].F && v[i].F <= 1000 && v[i].F == (int)v[i].F);
  }

  double tmp;
  assert(scanf("%lf", &tmp) != 1);

  sort(s, s + n, greater<T>()); 
  sort(v, v + k, greater<T>()); 
  if (k > n)
    k = n;

  dbl curt = 0;
  printf("%.20lf\n", CalcT());

  while (n > 0 && s[0].F > eps)
  { 
    m = 0, pos[0] = 0;
    forn(i, n)
      if (s[i].F > eps && (i == n - 1 || fabs(s[i].F - s[i + 1].F) > eps))
        pos[++m] = i + 1;
    forn(i, m)
    {
      vv[i] = 0;
      for (int j = pos[i]; j < pos[i + 1]; j++)
        if (j < k)
          vv[i] += v[j].F;
      vv[i] /= pos[i + 1] - pos[i];
    }

    dbl mi = 1e100;
    forn(i, m)
      if (vv[i] > eps)
        mi <?= s[pos[i]].F / vv[i];
    forn(i, m - 1)
      if (fabs(vv[i] - vv[i + 1]) > eps)
        mi <?= (s[pos[i]].F - s[pos[i + 1]].F) / (vv[i] - vv[i + 1]);

    forn(i, m)
      for (int j = pos[i]; j < pos[i + 1]; j++)
        s[j].F -= vv[i] * mi;

    int en = 0;
    forn(i, m)
    {
      int dp = pos[i + 1] - pos[i];
      dbl dt = mi / dp;
      forn(j, dp)
        if (pos[i] + j < k)
          forn(l, dp)
            e[en++] = event(curt + l * dt, pos[i] + (j + l) % dp, pos[i] + j);
    }
    sort(e, e + en);
    forn(i, en)
      printf("%.20lf %d %d\n", e[i].t, s[e[i].i].S + 1, v[e[i].j].S + 1);

    curt += mi;
  }
  return 0;
}
